Cgu::Callback::Callback_memfun< T, MemFunc, FreeArgs > Class Template Reference

`#include <callback.h>`

Inheritance diagram for Cgu::Callback::Callback_memfun< T, MemFunc, FreeArgs >:

## Public Member Functions

void | dispatch (typename Cgu::Param< FreeArgs >::ParamType... free_args) const
| Callback_memfun (T &obj_, MemFunc func_)
Public Member Functions inherited from Cgu::Callback::CallbackArg< FreeArgs... >
| CallbackArg ()
virtual | ~CallbackArg ()

## Constructor & Destructor Documentation

## Callback_memfun()

template<class T , class MemFunc , class... FreeArgs>

Cgu::Callback::Callback_memfun< T, MemFunc, FreeArgs >::Callback_memfun | ( | T & | obj_,
|  | MemFunc | func_
| ) |  |

inline

## Member Function Documentation

## dispatch()

template<class T , class MemFunc , class... FreeArgs>

void Cgu::Callback::Callback_memfun< T, MemFunc, FreeArgs >::dispatch | ( | typename Cgu::Param< FreeArgs >::ParamType... | args | ) | const

inline virtual

This will execute the referenced function, callable object or class method encapsulated by this class. It will only throw if the dispatched function, callable object or class method throws, or if the copy constructor of a free or bound argument throws and it is not a reference argument. It is thread safe if the referenced function or class method is thread safe.

Parameters

  args | The unbound arguments to be passed to the referenced function, callable object or class method, if any.

Note
  We use dispatch() to execute the callback, because the callback would normally be invoked through a base class pointer. To invoke it through operator()(), use the FunctorArg or SafeFunctorArg wrapper class.

Implements Cgu::Callback::CallbackArg< FreeArgs... >.

The documentation for this class was generated from the following file:

- callback.h